    All Packages  Class Hierarchy  This Package  Previous  Next  Index

# Class java.lang.ThreadGroup

    java.lang.Object
       |
       +----java.lang.ThreadGroup

public class ThreadGroup
extends Object

A thread group represents a set of threads. In addition, a thread group can also include other thread groups. The thread groups form a tree in which every thread group except the initial thread group has a parent.

A thread is allowed to access information about its own thread group, but not to access information about its thread group's parent thread group or any other thread groups.

##

ThreadGroup(String)
  Constructs a new thread group.
ThreadGroup(ThreadGroup, String)
  Creates a new thread group.

##

activeCount()
  Returns an estimate of the number of active threads in this thread group.
activeGroupCount()
  Returns an estimate of the number of active groups in this thread group.
allowThreadSuspension(boolean)
  Used by VM to control lowmem implicit suspension.
checkAccess()
  Determines if the currently running thread has permission to modify this thread group.
destroy()
  Destroys this thread group and all of its subgroups.
enumerate(Thread[])
  Copies into the specified array every active thread in this thread group and its subgroups.
enumerate(Thread[], boolean)
  Copies into the specified array every active thread in this thread group.
enumerate(ThreadGroup[])
  Copies into the specified array references to every active subgroup in this thread group.
enumerate(ThreadGroup[], boolean)
  Copies into the specified array references to every active subgroup in this thread group.
getMaxPriority()
  Returns the maximum priority of this thread group.
getName()
  Returns the name of this thread group.
getParent()
  Returns the parent of this thread group.
isDaemon()
  Tests if this thread group is a daemon thread group.
isDestroyed()
  Tests if this thread group has been destroyed.
list()
  Prints information about this thread group to the standard output.
parentOf(ThreadGroup)
  Tests if this thread group is either the thread group argument or one of its ancestor thread groups.
resume()
  Resumes all processes in this thread group.
setDaemon(boolean)
  Changes the daemon status of this thread group.
setMaxPriority(int)
  Sets the maximum priority of the group.
stop()
  Stops all processes in this thread group.
suspend()
  Suspends all processes in this thread group.
toString()
  Returns a string representation of this Thread group.
uncaughtException(Thread, Throwable)
  Called by the Java Virtual Machine when a thread in this thread group stops because of an uncaught exception.

##

ThreadGroup

     public ThreadGroup(String name)

  Constructs a new thread group. The parent of this new group is the thread group of the currently running thread.

  Parameters:
    name - the name of the new thread group.

ThreadGroup

     public ThreadGroup(ThreadGroup parent,
                        String name)

  Creates a new thread group. The parent of this new group is the specified thread group.

  The `checkAccess` method of the parent thread group is called with no arguments; this may result in a security exception.

  Parameters:
    parent - the parent thread group.
    name - the name of the new thread group.
  Throws: NullPointerException
    if the thread group argument is `null`.
  Throws: SecurityException
    if the current thread cannot create a thread in the specified thread group.
  See Also:
    SecurityException, checkAccess

##

getName

     public final String getName()

  Returns the name of this thread group.

  Returns:
    the name of this thread group.

getParent

     public final ThreadGroup getParent()

  Returns the parent of this thread group.

  Returns:
    the parent of this thread group. The top-level thread group is the only thread group whose parent is `null`.

getMaxPriority

     public final int getMaxPriority()

  Returns the maximum priority of this thread group. Threads that are part of this group cannot have a higher priority than the maximum priority.

  Returns:
    the maximum priority that a thread in this thread group can have.

isDaemon

     public final boolean isDaemon()

  Tests if this thread group is a daemon thread group. A daemon thread group is automatically destroyed when its last thread is stopped or its last thread group is destroyed.

  Returns:
    `true` if this thread group is a daemon thread group; `false` otherwise.

isDestroyed

     public synchronized boolean isDestroyed()

  Tests if this thread group has been destroyed.

setDaemon

     public final void setDaemon(boolean daemon)

  Changes the daemon status of this thread group.

  First, the `checkAccess` method of this thread group is called with no arguments; this may result in a security exception.

  A daemon thread group is automatically destroyed when its last thread is stopped or its last thread group is destroyed.

  Parameters:
    daemon - if `true`, marks this thread group as a daemon thread group; otherwise, marks this thread group as normal.
  Throws: SecurityException
    if the current thread cannot modify this thread.
  See Also:
    SecurityException, checkAccess

setMaxPriority

     public final void setMaxPriority(int pri)

  Sets the maximum priority of the group.

  First, the `checkAccess` method of this thread group is called with no arguments; this may result in a security exception.

  Threads in the thread group that already have a higher priority are not affected.

  Parameters:
    pri - the new priority of the thread group.
  Throws: SecurityException
    if the current thread cannot modify this thread group.
  See Also:
    SecurityException, checkAccess

parentOf

     public final boolean parentOf(ThreadGroup g)

  Tests if this thread group is either the thread group argument or one of its ancestor thread groups.

  Parameters:
    g - a thread group.
  Returns:
    `true` if this thread group is the thread group argument or one of its ancestor thread groups; `false` otherwise.

checkAccess

     public final void checkAccess()

  Determines if the currently running thread has permission to modify this thread group.

  If there is a security manager, its `checkAccess` method is called with this thread group as its argument. This may result in throwing a `SecurityException`.

  Throws: SecurityException
    if the current thread is not allowed to access this thread group.
  See Also:
    checkAccess

activeCount

     public int activeCount()

  Returns an estimate of the number of active threads in this thread group.

  Returns:
    the number of active threads in this thread group and in any other thread group that has this thread group as an ancestor.

enumerate

     public int enumerate(Thread list[])

  Copies into the specified array every active thread in this thread group and its subgroups.

  An application should use the `activeCount` method to get an estimate of how big the array should be. If the array is too short to hold all the threads, the extra threads are silently ignored.

  Parameters:
    list - an array into which to place the list of threads.
  Returns:
    the number of threads put into the array.
  See Also:
    activeCount

enumerate

     public int enumerate(Thread list[],
                          boolean recurse)

  Copies into the specified array every active thread in this thread group. If the `recurse` flag is `true`, references to every active thread in this thread's subgroups are also included. If the array is too short to hold all the threads, the extra threads are silently ignored.

  An application should use the `activeCount` method to get an estimate of how big the array should be.

  Parameters:
    list - an array into which to place the list of threads.
    recurse - a flag indicating whether also to include threads in thread groups that are subgroups of this thread group.
  Returns:
    the number of threads placed into the array.
  See Also:
    activeCount

activeGroupCount

     public int activeGroupCount()

  Returns an estimate of the number of active groups in this thread group.

  Returns:
    the number of active thread groups with this thread group as an ancestor.

enumerate

     public int enumerate(ThreadGroup list[])

  Copies into the specified array references to every active subgroup in this thread group.

  An application should use the `activeGroupCount` method to get an estimate of how big the array should be. If the array is too short to hold all the thread groups, the extra thread groups are silently ignored.

  Parameters:
    list - an array into which to place the list of thread groups.
  Returns:
    the number of thread groups put into the array.
  See Also:
    activeGroupCount

enumerate

     public int enumerate(ThreadGroup list[],
                          boolean recurse)

  Copies into the specified array references to every active subgroup in this thread group. If the `recurse` flag is `true`, references to all active subgroups of the subgroups and so forth are also included.

  An application should use the `activeGroupCount` method to get an estimate of how big the array should be.

  Parameters:
    list - an array into which to place the list of threads.
    recurse - a flag indicating whether to recursively enumerate all included thread groups.
  Returns:
    the number of thread groups put into the array.
  See Also:
    activeGroupCount

stop

     public final void stop()

  Stops all processes in this thread group.

  First, the `checkAccess` method of this thread group is called with no arguments; this may result in a security exception.

  This method then calls the `stop` method on all the threads in this thread group and in all of its subgroups.

  Throws: SecurityException
    if the current thread is not allowed to access this thread group or any of the threads in the thread group.
  See Also:
    SecurityException, stop, checkAccess

suspend

     public final void suspend()

  Suspends all processes in this thread group.

  First, the `checkAccess` method of this thread group is called with no arguments; this may result in a security exception.

  This method then calls the `suspend` method on all the threads in this thread group and in all of its subgroups.

  Throws: SecurityException
    if the current thread is not allowed to access this thread group or any of the threads in the thread group.
  See Also:
    SecurityException, suspend, checkAccess

resume

     public final void resume()

  Resumes all processes in this thread group.

  First, the `checkAccess` method of this thread group is called with no arguments; this may result in a security exception.

  This method then calls the `resume` method on all the threads in this thread group and in all of its sub groups.

  Throws: SecurityException
    if the current thread is not allowed to access this thread group or any of the threads in the thread group.
  See Also:
    SecurityException, resume, checkAccess

destroy

     public final void destroy()

  Destroys this thread group and all of its subgroups. This thread group must be empty, indicating that all threads that had been in this thread group have since stopped.

  Throws: IllegalThreadStateException
    if the thread group is not empty or if the thread group has already been destroyed.
  Throws: SecurityException
    if the current thread cannot modify this thread group.

list

     public void list()

  Prints information about this thread group to the standard output. This method is useful only for debugging.

uncaughtException

     public void uncaughtException(Thread t,
                                   Throwable e)

  Called by the Java Virtual Machine when a thread in this thread group stops because of an uncaught exception.

  The `uncaughtException` method of `ThreadGroup` does the following:

  - If this thread group has a parent thread group, the `uncaughtException` method of that parent is called with the same two arguments.
  - Otherwise, this method determines if the `Throwable` argument is an instance of `ThreadDeath`. If so, nothing special is done. Otherwise, the `Throwable`'s `printStackTrace` method is called to print a stack backtrace to the standard error stream.

  Applications can override this method in subclasses of `ThreadGroup` to provide alternative handling of uncaught exceptions.

  Parameters:
    t - the thread that is about to exit.
    e - the uncaught exception.
  See Also:
    err, ThreadDeath, printStackTrace

allowThreadSuspension

     public boolean allowThreadSuspension(boolean b)

  Used by VM to control lowmem implicit suspension.

toString

     public String toString()

  Returns a string representation of this Thread group.

  Returns:
    a string representation of this thread group.
  Overrides:
    toString in class Object

    All Packages  Class Hierarchy  This Package  Previous  Next  Index

Submit a bug or feature - Version 1.1.8 of Java Platform API Specification
Java is a trademark or registered trademark of Sun Microsystems, Inc. in the US and other countries.
Copyright 1995-1999 Sun Microsystems, Inc. 901 San Antonio Road,
Palo Alto, California, 94303, U.S.A. All Rights Reserved.